/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin.h>
#include <bin/mod.h>
#include <bin/types.h>
#include <caio.h>
#include <stdbool.h>
#include <stddef.h>

static int done(const enum state state, void *const args)
{
    struct bin_mod *const m = args;

    if (state)
        return -1;

    return bin_mod_unlock(m);
}

int bin_mod_read(void *const buf, const size_t n, void *const user)
{
    struct bin_mod *const m = user;
    const struct aio_done d =
    {
        .f = done,
        .args = m
    };

    const int r = caio_read(m->caio, buf, n, &d);

    if (r < 0)
        return -1;
    else if (!r && !caio_eof(m->caio))
        return bin_mod_lock(m);

    return r;
}
